//+------------------------------------------------------------------+
//|                                                     Laguerre.mq4 |
//|                                                     Emerald King |
//|                                     mailto:info@emerald-king.com |
//+------------------------------------------------------------------+
#property copyright "Emerald King"
#property link      "mailto:info@emerald-king.com"

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1 DeepSkyBlue
#property  indicator_color2 Gold
#property  indicator_color3 Magenta
#property  indicator_level1 0.83
#property  indicator_level2  0.55
#property  indicator_level3 0.17
//---- indicator parameters
extern double     PeriodFast=0.6;
extern double     PeriodMid=0.7;
extern double     PeriodSlow=0.8;

extern int CountBars=950;

double fL0=0,fL1=0,fL2=0,fL3=0,fL0A=0,fL1A=0,fL2A=0,fL3A=0,fLRSI=0;
double mL0=0,mL1=0,mL2=0,mL3=0,mL0A=0,mL1A=0,mL2A=0,mL3A=0,mLRSI=0;
double sL0=0,sL1=0,sL2=0,sL3=0,sL0A=0,sL1A=0,sL2A=0,sL3A=0,sLRSI=0;
double CU,CD;

double val11[];
double val12[];
double val13[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
      
int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,val11);
   SetIndexBuffer(1,val12);
   SetIndexBuffer(2,val13);
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   if (CountBars>Bars) CountBars=Bars;
   SetIndexDrawBegin(0,Bars-CountBars);
   
   int i;
   int    counted_bars=IndicatorCounted();

   //if(CountBars<=Lookback) return(0);
   //---- initial zero
   //if(counted_bars<1)
   //{
   //   for(i=1;i<=Lookback;i++) val1[CountBars-i]=0.0;
   //}

   i=CountBars-1;
   while(i>=0)
   {
      fL0A=fL0; fL1A=fL1; fL2A=fL2; fL3A=fL3;
      fL0= (1.0-PeriodFast)*Close[i]+PeriodFast*fL0A;
      fL1= - PeriodFast*fL0+fL0A+PeriodFast*fL1A;
      fL2= - PeriodFast*fL1+fL1A+PeriodFast*fL2A;
      fL3= - PeriodFast*fL2+fL2A+PeriodFast*fL3A;
      CU=0; CD=0;
      if(fL0>=fL1) CU=fL0-fL1; else CD=fL1-fL0;
      if(fL1>=fL2) CU=CU+fL1-fL2; else CD=CD+fL2-fL1;
      if(fL2>=fL3) CU=CU+fL2-fL3; else CD=CD+fL3-fL2;
      if(CU+CD!=0) fLRSI=CU/(CU+CD);
      val11[i] = fLRSI;
      mL0A=mL0; mL1A=mL1; mL2A=mL2; mL3A=mL3;
      mL0= (1.0-PeriodMid)*Close[i] + PeriodMid*mL0A;
      mL1= - PeriodMid*mL0+mL0A+PeriodMid*mL1A;
      mL2= - PeriodMid*mL1+mL1A+PeriodMid*mL2A;
      mL3= - PeriodMid*mL2+mL2A+PeriodMid*mL3A;
      CU=0; CD=0;
      if(mL0>=mL1) CU=mL0-mL1; else CD=mL1-mL0;
      if(mL1>=mL2) CU=CU+mL1-mL2; else CD=CD+mL2-mL1;
      if(mL2>=mL3) CU=CU+mL2-mL3; else CD=CD+mL3-mL2;
      if(CU+CD!=0) mLRSI=CU/(CU+CD);
      val12[i] = mLRSI;
      sL0A=sL0; sL1A=sL1; sL2A=sL2; sL3A=sL3;
      sL0=(1.0-PeriodSlow)*Close[i] + PeriodSlow*sL0A;
      sL1= - PeriodSlow*sL0+sL0A+PeriodSlow*sL1A;
      sL2= - PeriodSlow*sL1+sL1A+PeriodSlow*sL2A;
      sL3= - PeriodSlow*sL2+sL2A+PeriodSlow*sL3A;
      CU=0; CD=0;
      if(sL0>=sL1) CU=sL0-sL1; else CD=sL1-sL0;
      if(sL1>=sL2) CU=CU+sL1-sL2; else CD=CD+sL2-sL1;
      if(sL2>=sL3) CU=CU+sL2-sL3; else CD=CD+sL3-sL2;
      if(CU+CD!=0) sLRSI=CU/(CU+CD);
      val13[i] = sLRSI;
      i--;
	}
   return(0);
 }
//+------------------------------------------------------------------+